/*
GEST : GESTure Tracking
Copyright (C) 2006-2010  Brice Burger (LAAS-CNRS)
Ce code est protéger par une license APP
*/

#ifndef MESUREDISTANCE3D_H
#define MESUREDISTANCE3D_H

/* 
 * 
 * Ce fichier contient les fonctions nécessaires au calcul d'une image de distance à partir de coordonnées 3D.
 * 
 * \author BURGER Brice
 * \since 04/2007
 */

#include <cv.h>
#include <highgui.h>
#include "detectionParams.h"
#include "mesureDistance.h"
#include "projection.h"



class MesureDistance3D {

	MesureDistance *mesureDistanceG;
	MesureDistance *mesureDistanceD;
	
	/* pour la projection */
	int rayon;
	CvPoint point2dgauche, point2ddroite;
	
	public:

	/** Constructeur */
	MesureDistance3D();

	/** Destructeur */
	~MesureDistance3D();
	
	/** obtention de l'image de distance Gauche
	 * 
	 */
	IplImage* getImgDistG();

	/** obtention de l'image de distance Droite
	 * 
	 */
	IplImage* getImgDistD();
	
	/** calcule les images de distance gauche et droite dans la zone indiquée
	 *
	 * \param imgG,imgD : images à traiter
	 * \param zones : zones 3D de recherche du visage (sous forme des rectangles projetés sur les images) (NULL pour calculer sur toute l'image)
	 */
	void calculeImgDist(IplImage* imgG, IplImage* imgD, CvRect* zones);

};
#endif
