/*
GEST : GESTure Tracking
Copyright (C) 2006-2010  Brice Burger (LAAS-CNRS)
Ce code est protéger par une license APP
*/

#ifndef FACEDETECTOR_H
#define FACEDETECTOR_H

/**
 * \author BURGER Brice
 * \since 02/2007
 */
 
#include <cv.h>
#include <highgui.h>
#include <stdio.h>
#include <unistd.h>
#include <string>
#include <fstream>
#include <iostream>
using namespace std;

#include "detectionParams.h"


class faceDetector {

	/* la cascade de classifieur utilisée pour la détection de visages */
	CvHaarClassifierCascade* cascade;
  
	/* mémoire utilisée par le classifieur pour stocker la séquence des visages détectés */
	CvMemStorage* mem;

	/* stockage des visages */
	CvSeq* visagesSeq;//sous forme de séquence
	CvRect* rect;//rectangles extraits
	
	
	public:
	
	/** Constructeur
	 * 
	 * \param nomfichierclassifieurxml : le nom du fichier xml dans lequel est stocké l'apprentissage de visages
	 */
	faceDetector(string nomfichierclassifieurxml);

	/** Destructeur */
	~faceDetector();

	/** Éxécution de la détection de visage : 
	 * 
	 * \return cette fonction trouve le ou les visages dans l'image donnée en entrée
	 * \return elle renvoie un une structure contenant les rectangles extraits
	 */
	void trouve(IplImage* img, listeRect* visages);

};
#endif
