/* Copyright (c) Ludovic Brethes (LAAS-CNRS) */
#include "applipath.h"
#include "def_paramslist.h"
#include "globalParams.h"


#include <iostream.h>
#include <string>
using std::string;

#include "cvtcoloralloc.h"
#include "displayutils.h"
#include "temps_cpu.h"

int main(void)
{
  CvtColor* colorconverter;
  IplImage* img_in = cvLoadImage("cap000.jpg",-1);
  IplImage* img_out = cvCreateImage(cvGetSize(img_in),IPL_DEPTH_8U,3);

  /* conversion */
  ParamsList base = ParamsList(installpath+"config/color/ColorBaseList.txt");
  int from1 = base.getIndex("RGB");
  int from2 = base.getIndex("BGR");

  Show("IN",img_in,0,0,0);
  
  base = "YCrCb";
  colorconverter = CvtColorAlloc(from1,base.i(),320,240);
  colorconverter->convert(img_in,img_out);
  delete colorconverter;
  Show("RGB2YCrCb",img_out,300,0,0);
  colorconverter = CvtColorAlloc(from2,base.i(),320,240);
  get_time_start();
colorconverter->convert(img_in,img_out);
  get_time_stop();
Show("BGR2YCrCb",img_out,600,0,1);
  delete colorconverter;

  base = "HSV";
  colorconverter = CvtColorAlloc(from1,base.i(),320,240);
  colorconverter->convert(img_in,img_out);
  delete colorconverter;
  Show("RGB2HSV",img_out,300,0,0);
  colorconverter = CvtColorAlloc(from2,base.i(),320,240);
  get_time_start();
colorconverter->convert(img_in,img_out);
  get_time_stop();
Show("BGR2HSV",img_out,600,0,1);
  delete colorconverter;

/*
  colorconverter = CvtColorAlloc(4);
  colorconverter->convert(img_in,img_out);
  delete colorconverter;
  Show("RGB2Lab",img_out,300,0,0);
  colorconverter = CvtColorAlloc(5);
  colorconverter->convert(img_in,img_out);
  Show("BGR2Lab",img_out,600,0,1);
  delete colorconverter; 
*/

  base = "rgbN";
  colorconverter = CvtColorAlloc(from1,base.i(),320,240);

  get_time_start();
  colorconverter->convert(img_in,img_out);
  get_time_stop();

  delete colorconverter;
  Show("RGB2rgbN",img_out,300,0,0);
  colorconverter = CvtColorAlloc(from2,base.i(),320,240);
  colorconverter->convert(img_in,img_out);
  Show("BGR2rgbN",img_out,600,0,1);
  delete colorconverter;

  base = "Irg";
  colorconverter = CvtColorAlloc(from1,base.i(),320,240);
  get_time_start();
  colorconverter->convert(img_in,img_out);
  get_time_stop();


  /* Test Pixels */
  uchar r,g,b;
  uchar c1,c2,c3;

  cout << "RGB 2 Irg : \n";

  r = 0;
  g = 0;
  b = 0;
  colorconverter->convert(r,g,b,&c1,&c2,&c3);
  cout << (int)(r) << " " << (int)(g) << " " << (int)(b) << " ---> " << (int)(c1) << " " << (int)(c2) << " " << (int)(c3) << endl;

  r = 255;
  g = 255;
  b = 255;
  colorconverter->convert(r,g,b,&c1,&c2,&c3);
  cout << (int)(r) << " " << (int)(g) << " " << (int)(b) << " ---> " << (int)(c1) << " " << (int)(c2) << " " << (int)(c3) << endl;

  r = 0;
  g = 255;
  b = 0;
  colorconverter->convert(r,g,b,&c1,&c2,&c3);
  cout << (int)(r) << " " << (int)(g) << " " << (int)(b) << " ---> " << (int)(c1) << " " << (int)(c2) << " " << (int)(c3) << endl;

  r = 120;
  g = 30;
  b = 40;
  colorconverter->convert(r,g,b,&c1,&c2,&c3);
  cout << (int)(r) << " " << (int)(g) << " " << (int)(b) << " ---> " << (int)(c1) << " " << (int)(c2) << " " << (int)(c3) << endl;


  delete colorconverter;
  Show("RGB2Irg",img_out,300,0,0);
  colorconverter = CvtColorAlloc(from2,base.i(),320,240);
  
  IplImage *tt=cvCreateImage(cvSize(320,240),IPL_DEPTH_8U,3);
  IplImage *ttp1=cvCreateImage(cvSize(320,240),IPL_DEPTH_8U,1);
  IplImage *ttp2=cvCreateImage(cvSize(320,240),IPL_DEPTH_8U,1);
  IplImage *ttp3=cvCreateImage(cvSize(320,240),IPL_DEPTH_8U,1);

  cvSplit(img_in,ttp1,ttp2,ttp3,NULL);
  cvMerge(ttp3,ttp2,ttp1,NULL,tt);

  get_time_start();
  colorconverter->convert(tt,img_out);
  get_time_stop();

  cout << "BGR 2 Irg : \n";

  r = 0;
  g = 0;
  b = 0;
  colorconverter->convert(r,g,b,&c1,&c2,&c3);
  cout << (int)(r) << " " << (int)(g) << " " << (int)(b) << " ---> " << (int)(c1) << " " << (int)(c2) << " " << (int)(c3) << endl;

  r = 255;
  g = 255;
  b = 255;
  colorconverter->convert(r,g,b,&c1,&c2,&c3);
  cout << (int)(r) << " " << (int)(g) << " " << (int)(b) << " ---> " << (int)(c1) << " " << (int)(c2) << " " << (int)(c3) << endl;

  r = 0;
  g = 255;
  b = 0;
  colorconverter->convert(r,g,b,&c1,&c2,&c3);
  cout << (int)(r) << " " << (int)(g) << " " << (int)(b) << " ---> " << (int)(c1) << " " << (int)(c2) << " " << (int)(c3) << endl;

  r = 120;
  g = 30;
  b = 40;
  colorconverter->convert(r,g,b,&c1,&c2,&c3);
  cout << (int)(r) << " " << (int)(g) << " " << (int)(b) << " ---> " << (int)(c1) << " " << (int)(c2) << " " << (int)(c3) << endl;



  Show("BGR2Irg",img_out,600,0,1);

get_time_start();
  colorconverter->convert2(tt,img_out);
  get_time_stop();
  Show("BGR2Irg 2",img_out,600,0,1);
  delete colorconverter;
}
