/* Copyright (c) Ludovic Brethes (LAAS-CNRS) */
#ifndef VIDEO4LINUX_H
#define VIDEO4LINUX_H

#include <sys/types.h>
#include <linux/videodev.h>
#include <highgui.h>
#include "pwc-ioctl.h"
#include "yuv2rgb.h"
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <sys/mman.h>
#include <fstream>
#include <cv.h>

class video4linux 
{
public: 
  
  /** Constructeur pour l'acquisition video */
  video4linux(int width=320,int height=240);
  ~video4linux();

  bool init();
  bool grab();

 private:
  int SetRGBfromYUV420(IplImage * image, void*memorymap);
  struct video_capability vcap;
  struct video_channel Channel;
  struct video_picture picture;
  char * memorymap;
  int k;
  
  IplImage * rgbimg;

 public: // Public attributes

  /** descriptor of camera device */
  int camfd;
  /**  */
  struct video_mmap vmmap;
  /**  */
  struct video_mbuf mbuf;
  
  /** image width  */
  int width;

  /** image height */
  int height;

  /** image number */
  int number;

  /** image  */
  IplImage * image;
  
  /** read current image */
  inline IplImage * get() { return this->image; };

  /** grab new image and return it */
  inline IplImage * next() 
  { 
    if(grab()) return this->image;
    return 0;
  };

  /** return image width */
  inline int w() { return this->width; };

  /** return image height */
  inline int h() { return this->height; };

  /** return image number */
  inline int nb() { return this->number; };

};

#endif
