/* Copyright (c) Ludovic Brethes (LAAS-CNRS) */
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "videoimgseq.h"

videoimgseq::videoimgseq(string rep, string fileprefix, string ext, int deb, int fin, int nbdigits)
{
  this->rep = rep;
  this->fileprefix = fileprefix;
  this->ext = ext;
  this->deb = deb;
  this->fin = fin;
  this->nbdigits = nbdigits;
  this->number = 0;
  this->curimg = deb;
  sprintf(this->fileproto,"%s/%s%%0%dd.%s",this->rep.c_str(),this->fileprefix.c_str(),this->nbdigits,this->ext.c_str());
}

bool videoimgseq::init()
{
  return true;
}


bool videoimgseq::grab()
{
  /* check if there is a new image in the list */
  if(this->curimg>this->fin) return false;

  /* compute the current image filename */
  sprintf(this->filename, this->fileproto, this->curimg);

  //cout << "loading : " << this->filename << endl;
  
  /* load the image */
  this->image = cvLoadImage(this->filename,-1);
  this->curimg++;

  return true;
}

videoimgseq::~videoimgseq()
{

}
